/*************************************************************************
 *
 *  $RCSfile: XLanguageSourceCodeGenerator.java,v $
 *
 *  $Revision: 1.2.2.1 $
 *
 *  last change: $Author: kz $ $Date: 2007/01/29 17:36:58 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  the BSD license.
 *  
 *  Copyright (c) 2003 by Sun Microsystems, Inc.
 *  All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions
 *  are met:
 *  1. Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer.
 *  2. Redistributions in binary form must reproduce the above copyright
 *     notice, this list of conditions and the following disclaimer in the
 *     documentation and/or other materials provided with the distribution.
 *  3. Neither the name of Sun Microsystems, Inc. nor the names of its
 *     contributors may be used to endorse or promote products derived
 *     from this software without specific prior written permission.
 *
 *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 *  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 *  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 *  FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 *  COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 *  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 *  BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
 *  OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 *  ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
 *  TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 *  USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *     
 *************************************************************************/
import com.sun.star.uno.TypeClass;
import java.util.Vector;

public interface XLanguageSourceCodeGenerator {
    
    public String getHeaderSourceCode(Object _oUnoObject, String _sClassName, TypeClass _aTypeClass);
        
    public String getMainMethodSignatureSourceCode(XUnoNode _oUnoNode, String _soReturnObjectDescription);
    
    public String getMethodTerminationSourceCode();
    
    public String getqueryInterfaceSourceCode(String _sReturnValueDescription, String _sShortClassName, String _sObjectDescription);
    
    public String getPropertyValueGetterSourceCode(String _sPropertyName, String _sReturnVariableName, String _sIncomingObjectName);
            
    public String getObjectTypeDescription(String sShortClassName);
        
    public String getbooleanTypeDescription();

    public String getbyteTypeDescription();

    public String getshortTypeDescription();
    
    public String getunsignedshortTypeDescription();

    public String getlongTypeDescription();

    public String getunsignedlongTypeDescription();
    
    public String gethyperTypeDescription();

    public String getunsignedhyperTypeDescription();

    public String getfloatTypeDescription();
    
    public String getdoubleTypeDescription();

    public String getcharTypeDescription();
    
    public String getstringTypeDescription(boolean _bAsHeaderSourceCode);
    
    public String gettypeTypeDescription();
    
    public String getanyTypeDescription(boolean _bAsHeaderSourceCode);
    
    public String getArrayDeclaration(String sVariableDeclaration);
    
    public String getVariableDeclaration(String _sTypeString, String _sVariableName, boolean _bIsArray);
        
}
